<!-- TITLE -->
<app-header
    title="Agenda"
    subTitle="Votre disponibilité de consultation"
    color="grey-light"
    [border]="false"
>
</app-header>
<!-- Form -->
<ion-content color="grey-light">
    <ion-grid class="form ion-justify-content-between">
        <ion-list class="has-background-grey-light">
            <!-- Planning period -->
            <ion-item
                lines="none"
                class="ion-margin-top has-background-grey-light ion-align-items-start"
            >
                <ion-icon
                    name="ellipse"
                    color="grey-light"
                    size="medium"
                    slot="start"
                    class="mx-5"
                ></ion-icon>
                <ion-label class="ion-no-margin">
                    <!-- Title -->
                    <h3 class="weight-400 size-14 is-dark ion-no-margin">
                        Période de planification
                    </h3>
                    <!-- Description -->
                    <ion-text
                        class="size-11 weight-500 ion-text-wrap"
                        color="silver-dark"
                    >
                        Sur quelle plage de date êtes vous disponible ?
                    </ion-text>
                    <!-- Calendar -->
                    <ion-row>
                        <!-- Start date -->
                        <ion-col
                            size="auto"
                            class="is-blue ion-align-items-end form__period size-12"
                        >
                            Du
                            <ion-datetime-button
                                class="border-0 ml-3 ion-text-capitalize"
                                datetime="startDate"
                            >
                                <span slot="date-target">
                                    {{ startDate | date | titlecase }}</span
                                >
                            </ion-datetime-button>
                            <ion-modal [keepContentsMounted]="true">
                                <ng-template>
                                    <ion-datetime
                                        presentation="date"
                                        [showDefaultButtons]="true"
                                        id="startDate"
                                        [(ngModel)]="startDate"
                                        [min]="today"
                                        [firstDayOfWeek]="1"
                                        displayFormat="YYYY-MM-DD"
                                        [max]="maxYear"
                                        [isDateEnabled]="isDateEnabled"
                                        (ionChange)="updateEndDateMin()"
                                    ></ion-datetime>
                                </ng-template>
                            </ion-modal>
                        </ion-col>
                        <!-- End date -->
                        <ion-col
                            size="auto"
                            class="is-blue pl-0 ion-align-items-end form__period size-12"
                        >
                            au
                            <ion-datetime-button
                                class="border-0 ml-3"
                                datetime="endDate"
                            >
                                <span slot="date-target"
                                    >{{ endDate | date | titlecase }}</span
                                >
                            </ion-datetime-button>
                            <ion-modal [keepContentsMounted]="true">
                                <ng-template>
                                    <ion-datetime
                                        presentation="date"
                                        #endDateInput
                                        [showDefaultButtons]="true"
                                        id="endDate"
                                        [(ngModel)]="endDate"
                                        [min]="minEndDate"
                                        [firstDayOfWeek]="1"
                                        displayFormat="YYYY-MM-DD"
                                        [max]="maxYear"
                                        [isDateEnabled]="isDateEnabled"
                                        (ionChange)="updateEndDate()"
                                    >
                                    </ion-datetime>
                                </ng-template>
                            </ion-modal>
                        </ion-col>
                    </ion-row>
                </ion-label>
            </ion-item>
            <!-- Duration -->
            <ion-item lines="none">
                <ion-icon
                    name="ellipse"
                    color="grey-light"
                    size="medium"
                    slot="start"
                    class="mx-5"
                ></ion-icon>
                <ion-label
                    class="border-top-1 border-0 border-solid has-border-green-light"
                >
                    <!-- Title -->
                    <h3 class="mt-10 weight-400 size-14 ion-no-margin">
                        Durée
                    </h3>
                    <!-- Description -->
                    <ion-text
                        class="size-11 weight-500 ion-text-wrap"
                        color="silver-dark"
                    >
                        Combien de temps chaque rendez-vous doit -il durer ?
                    </ion-text>
                </ion-label>
            </ion-item>
            <ion-item lines="inset" class="form__duration">
                <ion-icon
                    name="ellipse"
                    color="grey-light"
                    size="medium"
                    slot="start"
                    class="mx-5"
                ></ion-icon>
                <ion-select
                    class="border-1 is-pale-stone weight-600 border-solid has-border-grey py-2 px-10 mb-10 radius-25 width-100"
                    [(ngModel)]="duration"
                    interface="popover"
                    backdrop="false"
                >
                    <ion-select-option
                        *ngFor="let option of durationOptions; trackBy: trackDuration"
                        [value]="option.value"
                    >
                        {{ option.label }}
                    </ion-select-option>
                </ion-select>
            </ion-item>
            <!-- Stop -->
            <ion-item lines="none">
                <ion-icon
                    name="time-outline"
                    size="medium"
                    color="grey-black"
                    slot="start"
                    class="mx-5 mt-5 ion-align-self-start"
                ></ion-icon>
                <ion-label>
                    <!-- Title -->
                    <h3 class="weight-400 size-14 ion-no-margin">Pause</h3>
                    <!-- Description -->
                    <ion-text
                        class="size-11 weight-500 ion-text-wrap"
                        color="silver-dark"
                    >
                        Indiquer le délai entre deux créneaux horaire
                    </ion-text>
                </ion-label>
            </ion-item>
            <ion-item lines="inset" class="form__duration">
                <ion-icon
                    name="ellipse"
                    color="grey-light"
                    size="medium"
                    slot="start"
                    class="mx-5"
                ></ion-icon>
                <ion-select
                    class="border-1 is-pale-stone weight-600 border-solid has-border-silver py-2 px-10 mb-10 radius-25 width-100"
                    [(ngModel)]="pause"
                    interface="popover"
                >
                    <ion-select-option
                        *ngFor="let option of pauseOptions; trackBy: trackDuration"
                        [value]="option.value"
                    >
                        {{ option.label }}
                    </ion-select-option>
                </ion-select>
            </ion-item>
            <!-- Availability -->
            <ion-item>
                <ion-icon
                    name="swap-horizontal-outline"
                    size="medium"
                    slot="start"
                    color="grey-black"
                    class="mx-5 mt-5 ion-align-self-start"
                ></ion-icon>
                <ion-label>
                    <!-- Title -->
                    <h3 class="weight-400 size-14 is-dark ion-no-margin">
                        Disponibilité habituelles
                    </h3>
                    <!-- Description -->
                    <ion-text
                        class="size-11 weight-500 ion-text-wrap"
                        color="silver-dark"
                    >
                        Définissez vos disponibilités habituelles pour les
                        rendez-vous
                    </ion-text>
                    <!-- Days of the weeks -->
                    <ion-row>
                        <ion-col
                            *ngFor="let day of daysOfWeek"
                            sizeXs="auto"
                            class="ion-no-padding"
                        >
                            <ion-chip
                                (click)="toggleDay(day)"
                                (keyPress)="toggleDay(day)"
                                class="form__availability size-8 weight-400 radius-15 px-10 py-3"
                                [outline]="true"
                                [ngClass]="{'has-background-green-light weight-700 is-white border-0': day.selected}"
                                >{{ day.name }}</ion-chip
                            >
                        </ion-col>
                    </ion-row>
                    <!-- Hours -->
                    <ion-row
                        class="ion-justify-content-between ion-margin-vertical"
                    >
                        <ion-col>
                            <ion-text class="size-14 is-dark-medium weight-400"
                                >Horaire</ion-text
                            >
                        </ion-col>
                        <ion-col size="auto">
                            <div
                                class="has-background-alto has-text-secondary p-4 ion-text-center width-120 weight-400 size-12"
                            >
                                <ion-text
                                    id="day-start-hour"
                                    class="ion-margin-end"
                                >
                                    {{dayStartHour}} </ion-text
                                >-
                                <ion-text
                                    class="ion-margin-start"
                                    id="day-end-hour"
                                >
                                    {{dayEndHour}}
                                </ion-text>
                            </div>
                        </ion-col>
                    </ion-row>
                    <!-- Start date -->
                    <ion-modal
                        trigger="day-start-hour"
                        class="ion-align-items-end"
                    >
                        <ng-template>
                            <ion-datetime
                                (ionChange)="onDateChange()"
                                size="cover"
                                presentation="time"
                                showDefaultButtons="true"
                                [(ngModel)]="dayStartHour"
                                cancelText="Annuler"
                                doneText="OK"
                            ></ion-datetime>
                        </ng-template>
                    </ion-modal>
                    <!-- End date -->
                    <ion-modal
                        trigger="day-end-hour"
                        class="ion-align-items-end"
                    >
                        <ng-template>
                            <ion-datetime
                                (ionChange)="onDateChange()"
                                size="cover"
                                presentation="time"
                                showDefaultButtons="true"
                                [(ngModel)]="dayEndHour"
                                cancelText="Annuler"
                                doneText="OK"
                            ></ion-datetime>
                        </ng-template>
                    </ion-modal>
                </ion-label>
            </ion-item>
            <!-- Color -->
            <ion-item lines="none">
                <ion-icon
                    name="settings-outline"
                    size="medium"
                    slot="start"
                    color="grey-black"
                    class="mx-5 mt-5 ion-align-self-start"
                ></ion-icon>
                <ion-label>
                    <!-- Title -->
                    <h3 class="weight-400 size-14 is-dark ion-no-margin">
                        Couleur
                    </h3>
                    <ion-row>
                        <ion-col size="10" class="pl-0">
                            <!-- Description -->
                            <ion-text
                                class="size-11 weight-500 ion-text-wrap"
                                color="silver-dark"
                            >
                                Personnalisez la couleur par défaut de vos
                                rendez-vous
                            </ion-text>
                        </ion-col>
                        <ion-col size="2" class="ion-text-end size-14">
                            <ion-icon
                                name="ellipse"
                                class="size-42"
                                [color]="selectedColor"
                                id="color-picker"
                            ></ion-icon>
                        </ion-col>
                    </ion-row>
                    <!-- Color list -->
                    <ion-modal
                        trigger="color-picker"
                        class="ion-align-items-end"
                    >
                        <ng-template>
                            <ion-row class="ion-justify-content-around">
                                <ion-col
                                    *ngFor="let color of colors"
                                    size="auto"
                                >
                                    <ion-icon
                                        (click)="selectColor(color)"
                                        (keyPress)="selectColor(color)"
                                        name="ellipse"
                                        size="large"
                                        [color]="color"
                                    ></ion-icon>
                                </ion-col>
                            </ion-row>
                        </ng-template>
                    </ion-modal>
                </ion-label>
            </ion-item>
            <!-- error -->
            <div class="ion-text-center size-10">
                <ion-text data-test-id="errorMessage" color="danger"
                    >{{error.value}}</ion-text
                >
            </div>
        </ion-list>
        <!-- Submit -->
        <ion-row
            class="ion-justify-content-center ion-margin-vertical weight-500 ion-margin-top"
        >
            <ion-col sizeXs="8" sizeSm="6" class="is-white">
                <app-button
                    title="Valider"
                    [loading]="loading.getValue()"
                    (click)="onSubmit()"
                    (keyPress)="onSubmit()"
                    shape="round"
                    color="primary"
                    expand="full"
                >
                </app-button>
            </ion-col>
        </ion-row>
    </ion-grid>
</ion-content>
